"use strict";

exports.__esModule = true;
var createExecute = exports.createExecute = function createExecute() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$log = _ref.log,
      log = _ref$log === undefined ? false : _ref$log;

  return function (_ref2) {
    var dispatch = _ref2.dispatch,
        getState = _ref2.getState;
    return function (next) {
      return function (action) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        if (typeof action === "function") {
          if (log) {
            // eslint-disable-next-line no-console
            console.log("Effect:", action.name, "Arguments:", args);
          }
          var effect = action.apply(undefined, args);

          if (typeof effect !== "function") {
            throw new TypeError("Effect should return `function(dispatch, getState){}`. " + "Maybe you passed actionCreator to dispatch without call it?");
          }

          return effect(dispatch, getState);
        }
        return next.apply(undefined, [action].concat(args));
      };
    };
  };
};